#include <stdio.h>
#include <stdlib.h>

/* matMul.c: matrix multiplication in 1D representation of matrices */

/*
 * Calculate C = A * B
 * A, B, C: 1D-array representation of matrices (size x strd).
 * Thus, the (i,j) element is accessed by A[i * strd + j], etc.
 */

void matMul(double *matA, double *matB, double *matC, int size, int strd) {
    /* local variables */
    int i,j,k;

    /* initialize */
    for (i=0; i<size; i++) {
        for (j=0; j<size; j++) {
            matC[i * strd + j] = 0.e0;
        }
    }

    /* matrix multiplication */
    for (i=0; i<size; i++) {
        for (j=0; j<size; j++) {
            for (k=0; k<size; k++) {
                matC[i * strd + j] += matA[i * strd + k]*matB[k * strd + j];
            }
        }
    }
}
