#include <stdio.h>
#include <stdlib.h>

/* matMul2d.c: matrix multiplication in 2D representation of matrices */

/*
 * Calculate C = A * B
 * A, B, C: 2D-array representation of matrices (size x strd).
 * Thus, the (i,j) element is accessed by A[i][j], etc.
 */

void matMul(double **matA, double **matB, double **matC,
	int size, int strd) {
    /* local variables */
    int i,j,k;

    /* initialize */
    for (i=0; i<size; i++) {
        for (j=0; j<size; j++) {
            matC[i][j] = 0.e0;
        }
    }

    /* matrix multiplication */
    for (i=0; i<size; i++) {
        for (j=0; j<size; j++) {
            for (k=0; k<size; k++) {
                matC[i][j] += matA[i][k]*matB[k][j];
            }
        }
    }
}
