#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern double second();

int main(int argc, char* argv[]) {
    int size[] = {16, 32, 64, 128, 256, 512, 1024, 2048};
    int i, j, nitera, n, Nsize=8, sz, it, strd;
    double *matA, *matB, *matC;
    double coef, pi, fact, err, diff, R;
    double t0, t1, gflops;
    double tmin=10.e0;
    /* initialize */
    pi = 4.e0*atan(1.e0);
    if (Nsize > 8) Nsize=8;

    printf("\n\n Matrix multiplication in 1D-representation\n");
    printf(" CPU time is measured.\n");
    printf(" Minimum duration for a measurement is 10 (sec).\n\n");
    printf(" size   time(sec)    n Calc     Gflops      ERROR\n");
    printf("----- ------------ ---------- ----------- -------------\n");
    for (sz=0; sz<Nsize; sz++) {
	n = size[sz];
        strd = n;
	coef = sqrt(2.e0/n);
	fact = pi/n;
	matA = (double*)malloc( sizeof(double) * n * strd );
	matB = (double*)malloc( sizeof(double) * n * strd );
	matC = (double*)malloc( sizeof(double) * n * strd );
	for (i=0; i<n; i++) {
	    for (j=0; j<n; j++) {
		matA[i*strd+j] = coef * sin( fact*(i-j) );
		matB[i*strd+j] = coef * cos( fact*(i-j) );
	    }
	}
	nitera=it=1;
	t0 = second();
	while (1) {
	    matMul(matA, matB, matC, n, strd);
	    t1 = second();
	    if ( it >= nitera ) {
		if ( (t1-t0) >= tmin ) {
		    break;
		} else {
		    nitera *= 2;
		}
	    }
	    it++;
	}
	/* check result */
	gflops = nitera*2.e0*n*n*n/(t1-t0)*1.e-9;
	err = 0.e0;
	for (i=0; i<n; i++) {
	    for (j=0; j<n; j++) {
		diff = sin( fact*(i-j) ) - matC[i*strd+j];
		err += (diff*diff);
	    }
	}
	R = sqrt(err);
	printf("%5d  %10.5f  %9d  %10.6f  %12.5e\n",
		n, (t1-t0), nitera, gflops, R);
	free(matA);
	free(matB);
	free(matC);
    }
    printf("----- ------------ ---------- ----------- -------------\n");
    return 0;
}
